#ifndef _UTIL_ASSERT_H
#define _UTIL_ASSERT_H

#ifndef _UTIL_ASSERT_LEVEL
#define _UTIL_ASSERT_LEVEL 1
#endif

namespace Assert {
	enum {
		Always = 0,
		Normal = 1,
		Excessive = 2
	};

	static inline void __attribute__((always_inline))
	do_assert(const char *file, int line, bool condition, int level)
	{
		void level_must_be_const();
	
		if (!__builtin_constant_p(level))
			level_must_be_const();
		
		if (level <= _UTIL_ASSERT_LEVEL && __builtin_expect(!condition, 0))
			assert_failure(file, line);
	}
}

#define assertl(cond, level) (::Assert::do_assert(__FILE__, __LINE__, cond, level))
#define BUG() assertl(0, ::Assert::Always)

#endif
