#ifndef _C_STRING_H
#define _C_STRING_H

#include <stddef.h>

#ifdef __cplusplus
extern "C" {
#endif

	void *memcpy(void *dest, const void *src, size_t len);
	void *memmove(void *dest, const void *src, size_t len);
	int memcmp(const void *b1, const void *b2, size_t len);
	void *memset(void *block, int count, size_t len);
	size_t strnlen(const char *s, size_t n);
	size_t strlen(const char *s);
	char *strcpy(char *dest, const char *src);
	char *strncpy(char *dest, const char *src, size_t len);
	char *strcat(char *dest, const char *src);
	char *strncat(char *dest, const char *src, size_t len);
	int strcmp(const char *s1, const char *s2);
	int strncmp(const char *s1, const char *s2, int n);

#ifdef __cplusplus
	char *strchr(char *s, int c);
}

static inline const char *strchr(const char *s, int c)
{
	return const_cast<const char *>(strchr(const_cast<char *>(s), c));
}
#else
char *strchr(const char *s, int c);
#endif

#endif
