#ifndef _ARCH_PAGING_H
#define _ARCH_PAGING_H

#include <System/Mem.h>

#include <kern/types.h>
#include <arch/addrs.h>

namespace Mem {
	union PTEFlags;
};

namespace Arch {
	static const ulong page_size = 4096;
	static const int page_shift = 12;
	
	// x64 does not have cache alias issues.
	static const ulong page_mapping_min_align = 4096;

	static const ulong user_start = 0;
	static const ulong user_end = 0x00007fffffffffff;
}

#endif
