#ifndef _ARCH_ADDRS_H
#define _ARCH_ADDRS_H

#define PHYSMEM_START 0x80000000
#define KERNEL_START PHYSMEM_START

#ifdef __cplusplus
#include <kern/types.h>

namespace Arch {
	static inline ulong kvirt_to_phys(void *addr)
	{
		return reinterpret_cast<ulong>(addr) - PHYSMEM_START;
	}

	static inline void *phys_to_kvirt(ulong addr)
	{
		return reinterpret_cast<void *>(addr + PHYSMEM_START);
	}
	
	namespace Priv {
		static const ulong max_ktext_map = 4 * 1024 * 1024;
	}

	// Allow some room for these regions to grow if needed
	// (8 pages each should be more than sufficient).
	static const ulong roshared_map = 0x7fff0000;
	static const ulong rwshared_map = 0x7fff8000;
	
	static const ulong stack_bottom = 0x7f000000;
	static const ulong stack_top = 0x7ffeffff;
	static const bool stack_grows_up = false;
};

#endif
#endif
