#ifndef _KERN_EVENT_H
#define _KERN_EVENT_H

#include <System/Events.h>

namespace Event {
	using System::VStruct;
	using System::Events::Event;
	using namespace System::Notifiers;

	class EventTrigger {
	public:
		#include <servers/core/event/Event/EventTrigger.h>
		
		EventTrigger()
		{
			init_iface();
		}
		
		virtual ~EventTrigger()
		{
		}
		
		virtual void notify(VStruct *info) = 0;
	};

	class SyncEventTrigger {
		EventTrigger *real_trigger;
	
	public:
		#include <servers/core/event/Event/SyncEventTrigger.h>

		SyncEventTrigger(EventTrigger *real)
		{
			real_trigger = real;
			init_iface();
		}

		void notify(VStruct *info)
		{
			real_trigger->notify(info);
		}
	};

	class EventDispatcher {
	public:
		#include <servers/core/event/Event/EventDispatcher.h>

		EventDispatcher()
		{
			init_iface();
		}

		void setup_trigger(Event *event, Notifier *trigger);
		void setup_sync_trigger(Event *event, SyncNotifier *trigger);
		
		typedef void (*KFunc)(VStruct *info);
		
		void setup_kfunc_event(KFunc func, SyncNotifier *trigger);
 	};
}

#include <servers/core/event/footer.cc>

#endif
